# Cinder

# cinder::gl::Texture::Format Struct Reference

`#include <Texture.h>`

List of all members.

## Public Member Functions
| Format ()
| Default constructor, sets the target to `GL_TEXTURE_2D`, wrap to `GL_CLAMP`, disables mipmapping, the internal format to "automatic".
void | setTarget (GLenum target)
| Specifies the texture's target. The default is `GL_TEXTURE_2D`.
void | setTargetRect ()
| Sets the texture's target to be `GL_TEXTURE_RECTANGLE_ARB`. Not available in OpenGL ES.
void | enableMipmapping (bool enableMipmapping=true)
| Enables or disables mipmapping. Default is disabled.
void | setInternalFormat (GLint internalFormat)
| Sets the Texture's internal format. A value of -1 implies selecting the best format for the context.
void | setAutoInternalFormat ()
| Sets the Texture's internal format to be automatically selected based on the context.
void | setWrap (GLenum wrapS, GLenum wrapT)
| Sets the wrapping behavior when a texture coordinate falls outside the range of [0,1]. Possible values are `GL_CLAMP`, `GL_REPEAT` and `GL_CLAMP_TO_EDGE`. The default is `GL_CLAMP`.
void | setWrapS (GLenum wrapS)
| Sets the horizontal wrapping behavior when a texture coordinate falls outside the range of [0,1]. Possible values are `GL_CLAMP`, `GL_REPEAT` and `GL_CLAMP_TO_EDGE`. The default is `GL_CLAMP_TO_EDGE`.
void | setWrapT (GLenum wrapT)
| Sets the verical wrapping behavior when a texture coordinate falls outside the range of [0,1]. Possible values are `GL_CLAMP`, `GL_REPEAT` and `GL_CLAMP_TO_EDGE`. The default is `GL_CLAMP_TO_EDGE`.
void | setMinFilter (GLenum minFilter)
| Sets the filtering behavior when a texture is displayed at a lower resolution than its native resolution. Default is `GL_LINEAR` Possible values are.
void | setMagFilter (GLenum magFilter)
GLenum | getTarget () const
| Returns the texture's target.
bool | hasMipmapping () const
| Returns whether the texture has mipmapping enabled.
GLint | getInternalFormat () const
| Returns the Texture's internal format. A value of -1 implies automatic selection of the internal format based on the context.
bool | isAutoInternalFormat () const
| Returns whether the Texture's internal format will be automatically selected based on the context.
GLenum | getWrapS () const
| Returns the horizontal wrapping behavior for the texture coordinates.
GLenum | getWrapT () const
| Returns the vertical wrapping behavior for the texture coordinates.
GLenum | getMinFilter () const
| Returns the texture minifying function, which is used whenever the pixel being textured maps to an area greater than one texture element.
GLenum | getMagFilter () const
| Returns the texture magnifying function, which is used whenever the pixel being textured maps to an area less than or equal to one texture element.
## Protected Attributes
GLenum | mTarget
GLenum | mWrapS
GLenum | mWrapT
GLenum | mMinFilter
GLenum | mMagFilter
bool | mMipmapping
GLint | mInternalFormat
## Friends
class | Texture

## Constructor & Destructor Documentation

cinder::gl::Texture::Format::Format | ( |  | ) |

Default constructor, sets the target to `GL_TEXTURE_2D`, wrap to `GL_CLAMP`, disables mipmapping, the internal format to "automatic".

## Member Function Documentation

void cinder::gl::Texture::Format::setTarget | ( | GLenum | target | ) |

Specifies the texture's target. The default is `GL_TEXTURE_2D`.

void cinder::gl::Texture::Format::setTargetRect | ( |  | ) |

Sets the texture's target to be `GL_TEXTURE_RECTANGLE_ARB`. Not available in OpenGL ES.

void cinder::gl::Texture::Format::enableMipmapping | ( | bool | enableMipmapping = `true` | ) |

Enables or disables mipmapping. Default is disabled.

void cinder::gl::Texture::Format::setInternalFormat | ( | GLint | internalFormat | ) |

Sets the Texture's internal format. A value of -1 implies selecting the best format for the context.

void cinder::gl::Texture::Format::setAutoInternalFormat | ( |  | ) |

Sets the Texture's internal format to be automatically selected based on the context.

void cinder::gl::Texture::Format::setWrap | ( | GLenum | wrapS,
|  | GLenum | wrapT |
| ) |  |  |

Sets the wrapping behavior when a texture coordinate falls outside the range of [0,1]. Possible values are `GL_CLAMP`, `GL_REPEAT` and `GL_CLAMP_TO_EDGE`. The default is `GL_CLAMP`.

void cinder::gl::Texture::Format::setWrapS | ( | GLenum | wrapS | ) |

Sets the horizontal wrapping behavior when a texture coordinate falls outside the range of [0,1]. Possible values are `GL_CLAMP`, `GL_REPEAT` and `GL_CLAMP_TO_EDGE`. The default is `GL_CLAMP_TO_EDGE`.

void cinder::gl::Texture::Format::setWrapT | ( | GLenum | wrapT | ) |

Sets the verical wrapping behavior when a texture coordinate falls outside the range of [0,1]. Possible values are `GL_CLAMP`, `GL_REPEAT` and `GL_CLAMP_TO_EDGE`. The default is `GL_CLAMP_TO_EDGE`.

void cinder::gl::Texture::Format::setMinFilter | ( | GLenum | minFilter | ) |

Sets the filtering behavior when a texture is displayed at a lower resolution than its native resolution. Default is `GL_LINEAR` Possible values are.

- `GL_NEAREST`
- `GL_LINEAR`
- `GL_NEAREST_MIPMAP_NEAREST`
- `GL_LINEAR_MIPMAP_NEAREST`
- `GL_NEAREST_MIPMAP_LINEAR`
- `GL_LINEAR_MIPMAP_LINEAR`

void cinder::gl::Texture::Format::setMagFilter | ( | GLenum | magFilter | ) |

Sets the filtering behavior when a texture is displayed at a higher resolution than its native resolution. Default is `GL_LINEAR` Possible values are

- `GL_NEAREST`
- `GL_LINEAR`
- `GL_NEAREST_MIPMAP_NEAREST`
- `GL_LINEAR_MIPMAP_NEAREST`
- `GL_NEAREST_MIPMAP_LINEAR`
- `GL_LINEAR_MIPMAP_LINEAR`

GLenum cinder::gl::Texture::Format::getTarget | ( |  | ) | const

Returns the texture's target.

bool cinder::gl::Texture::Format::hasMipmapping | ( |  | ) | const

Returns whether the texture has mipmapping enabled.

GLint cinder::gl::Texture::Format::getInternalFormat | ( |  | ) | const

Returns the Texture's internal format. A value of -1 implies automatic selection of the internal format based on the context.

bool cinder::gl::Texture::Format::isAutoInternalFormat | ( |  | ) | const

Returns whether the Texture's internal format will be automatically selected based on the context.

GLenum cinder::gl::Texture::Format::getWrapS | ( |  | ) | const

Returns the horizontal wrapping behavior for the texture coordinates.

GLenum cinder::gl::Texture::Format::getWrapT | ( |  | ) | const

Returns the vertical wrapping behavior for the texture coordinates.

GLenum cinder::gl::Texture::Format::getMinFilter | ( |  | ) | const

Returns the texture minifying function, which is used whenever the pixel being textured maps to an area greater than one texture element.

GLenum cinder::gl::Texture::Format::getMagFilter | ( |  | ) | const

Returns the texture magnifying function, which is used whenever the pixel being textured maps to an area less than or equal to one texture element.

## Friends And Related Function Documentation

friend class Texture`[friend]`

## Member Data Documentation

GLenum cinder::gl::Texture::Format::mTarget`[protected]`

GLenum cinder::gl::Texture::Format::mWrapS`[protected]`

GLenum cinder::gl::Texture::Format::mWrapT`[protected]`

GLenum cinder::gl::Texture::Format::mMinFilter`[protected]`

GLenum cinder::gl::Texture::Format::mMagFilter`[protected]`

bool cinder::gl::Texture::Format::mMipmapping`[protected]`

GLint cinder::gl::Texture::Format::mInternalFormat`[protected]`

The documentation for this struct was generated from the following files:

- include/cinder/gl/Texture.h
- src/cinder/gl/Texture.cpp